﻿using Ozeki.VoIP;
using System;
using Ozeki.Media;

namespace _05_IVR_using_XML_basic
{
    class PlayCommand : ICommand
    {
      //  ICall _call;
        PhoneCallAudioSender _phoneCallAudioSender = new PhoneCallAudioSender();
        MediaConnector _mediaConnector = new MediaConnector();
        MP3StreamPlayback _mp3Player;
        string _path;
        
        public PlayCommand(string path)
        {
            _path = path;
        }

        public void Start(ICall call)
        {
          //  _call = call;
            _phoneCallAudioSender.AttachToCall(call);
            MP3ToSpeaker(_path);
        }

        private void MP3ToSpeaker(string path)
        {
            DisposeMediaConnection();
            _mediaConnector = new MediaConnector();
            _mp3Player = new MP3StreamPlayback(path);
            _mp3Player.Stopped += mp3Player_Stopped;

            _mediaConnector.Connect(_mp3Player, _phoneCallAudioSender);
            _mp3Player.Start();
        }

        void mp3Player_Stopped(object sender, EventArgs e)
        {
            DisposeMediaConnection();

            var handler = Completed;
            if (handler != null)
                handler(this, EventArgs.Empty);
        }

        public void Cancel()
        {
            DisposeMediaConnection();
        }

        public event EventHandler Completed;

        void DisposeMediaConnection()
        {
            _mediaConnector.Dispose();

            if (_mp3Player != null)
            {
                _mediaConnector.Disconnect(_mp3Player, _phoneCallAudioSender);
            }
        }
    }
}
